Attribute VB_Name = "sb_major"

Public n_pge As Integer         'Number of pages in set.
Public p_n As Integer           'Page number in set.
Public print_depth As Single    'Printing depth for 'create_page' routine.

Public pge_txt() As String      'Sample text for display.
Public frm_text As String
Public path As String           'Application path.

Public setup As Boolean         'Main data set-up flag.
Public canceled As Boolean      'CANCELed flag.

Public PP_ps As PPpages         'PP_pages' object.
Public PP_p() As PPpage         'Array for individual 'PP_page' objects.

Sub set_up()
 
    setup = False

    path = App.path + "\"
 
    Set PP_ps = New PPpages     'Define the 'Pages' object and
    preview.set_PPpages PP_ps   'use it to define the Preview form PPpages object.
    
    ReDim pge_txt(4)            'Text items for use with the 'add_text' routine.
    pge_txt(0) = "This is a test"
    pge_txt(1) = " with a bit more. "
    pge_txt(2) = "This is in a larger font size "
    pge_txt(3) = "with an extra bit ."
    pge_txt(4) = "This is smaller."
    
    'Text to illustrate the use of the 'add_f_text' routine.
    frm_text = "This is a long \q12/section\n/ of text with built in\b/ formatting commands" _
                + ", (the last section\n/ should be in bold). This is to test the " _
                + "various functions of the \i/'add_f_text'\n/ routine. This illustrates " _
                + "\s/super\n/scripts and \p/sub\n/scripts. This a change of \20/font size\n/" _
                + " then \u/underline and\t/ strikethrough\n/. This shows the use of a " _
                + "backspace to place an I over an O, O\k/I\n/, and to create \y17b/m\ns/3\kp/n\n/."
    setup = True
End Sub

Sub page()

    'Define basic page parameters.
    PP_ps.page_parms vbPRPSA4, vbPRORPortrait, 0.8, 0.4, 0.6, 0.4, 0.8, 0.8, 1, RGB(210, 255, 255) 'Inch units.
    'PP_ps.page_parms vbPRPSA4, vbPRORPortrait, 20, 15, 20, 15, 20, 20, 1 'mm. units.
    'c_p.set_sizes 11, RGB(210, 255, 255)
    n_pge = 4           'Declare the number of pages and
    ReDim PP_p(n_pge)   'dimension the page array to fit, (use 1 to n_pge).
    For j = 1 To n_pge
        Set PP_p(j) = PP_ps.Add(j, j + 3)   'Make the LOCAL page numbers 1 - 4 and
    Next                                    'the ABSOLUTE 4 - 7.

    create_page 1, 1, 1 'Create a page for Preview.
    
End Sub

'Routine to create a Print/Preview page.
'This is a generalised routine which acts as a container for specific, program routines.
'Its minimum requirements are the three parameters used below.

'It must exist as it is used by the Class routines to re-create specific pages.

'No assumption is made concerning the main program 'PP_page' object. The collection item
'index of the requested page is found and used to define a local 'PP_page' object which
'is used to define the page text.

'It could respond to a main program, option variable to select a variety of outputs.

'Procedure name:    create_page(fl, zm, lpn)
'Parameters:        fl;     the Print/Preview flag,
'                   zm;     the zoom factor,
'                   lpn;    the LOCAL page number.

Sub create_page(fl, zm, lpn)
   
    'THIS FIRST SECTION IS GENERAL TO ALL PAGES.
     
    p_n = lpn   'Local storage for the page number.
    
    Dim c_p As PPpage, col As Collection    'Declare page and collection objects.
    Dim hpp, prnt_depth, p_lin, pd As Single
    Dim pl As Single
    
    indx = PP_ps.find_index((lpn))  'Find the index of the Page 'lpn'.
    If indx > 0 Then                'There is a valid page, so
        Set col = PP_ps.page_col    'define the collection object and
        Set c_p = col(indx)         'the 'PP_page' object.
    
        c_p.set_pp = fl     'Set the Print/Preview flag and
        c_p.set_zoom = zm   'the zoom factor.
       
'******************************CREATE THE PAGE TEXT************************************

'       The following code is application specific.

        c_p.set_object                      'Set the display object for this page to the default, the Preview Box.
       
        c_p.font "Century Gothic", 14       'Set the font name and size.
    
        lh = c_p.line_height    'Store the current new line height.
 
        'Header with SHORT DATE at left, text in the centre and page number in ROMAN numerals at the right.
        c_p.head_foot 0, "sd", "Test page", "pr", "Arial", 10, True
        
        'This sets the initial printing at the TOP margin.
        prnt_depth = c_p.page_data(2)
 
        c_p.set_align 3 'Set the global alignment to 3 = FULL JUSTIFICATION.
        
        pl = 0  'Initialise the partial line variable.
        
        'Add formatted text using double line height.
        c_p.add_f_text frm_text, prnt_depth, , , pl, (lh)
        
        'Repeat the same text using single height but with an indent of 0.5"
        c_p.add_f_text frm_text, , True, , pl, , -0.5
        
        'Add a graphic, half the page width and in the original proportion.
        c_p.add_graphic path + "shd_bdr.jpg", -0.5
        
        'Footer with LONG DATE at the left, page number in ARABIC numerals in the centre and text at the right.
        c_p.head_foot 1, "ld", "pa", " 2007", "Arial", 10, True
        
'**************************************************************************************
    
    'THIS FINAL SECTION IS GENERAL TO ALL PAGES.
    
        PP_ps.print_it lpn      'Print/Preview the page.
 
    Else
        MsgBox "Bad index!", vbOKOnly + vbCritical, "MAIN PROGRAM  ERROR"
        canceled = True
    End If
    
End Sub

'The contents of the following procedure should be used to replace the 'add_f_text'
'code in the above 'create_page' procedure to demonstrate the use of the 'add_text'
'procedure.

Sub alternative_text()

'******************************CREATE THE PAGE TEXT************************************
'       The following code is application specific.

        c_p.font "Century Gothic", 14   'Set the font name and size.
        
        print_depth = c_p.page_data(2) 'This sets the initial printing at the TOP margin.

        c_p.header "Test page", "Arial", 10, True  'Header with default, CENTER, alignment.
    
        hpp = 0
        c_p.add_text pge_txt(0), hpp, False, print_depth
        c_p.add_text pge_txt(1), hpp, True, print_depth
        hpp = 0
        c_p.font , 20   'Set the font name and size.
        c_p.add_text pge_txt(2), hpp, False, print_depth
        c_p.add_text pge_txt(3), hpp, False, print_depth
        c_p.font , 10, , , , , vbRed    '(255), Set the size and colour RED.
        c_p.add_text pge_txt(4), hpp, True, print_depth
        c_p.set_font 0, 6   'Reset the font colour to black the easy way!
        
        c_p.footer True, "Arial", 10, True  'Footer with default alignments, DATE at LEFT, PAGE NO. CENTRE.
'**************************************************************************************
    

End Sub
